require 'moonloader'
imgui = require 'imgui'
encoding = require("encoding"); encoding.default = 'CP1251'; u8 = encoding.UTF8  
json = setmetatable({defPath = getWorkingDirectory()..'/config/',
    save = function(t,path) 
        if not path:find('[\\/]') then;  path = json.defPath..path end
        if not doesDirectoryExist(path:match('(.+)/.+%.%S+$')) then createDirectory(path:match('(.+)/.+%.%S+$')) end
        t = (t == nil and {} or (type(t) == 'table' and t or {}))
        local f = io.open(path,'w');    f:write(encodeJson(t) or {});   f:close()
    end,
    load = function(t,path) 
        if not path:find('[\\/]') then;  path = json.defPath..path end
        if (not doesFileExist(path) or not doesDirectoryExist((path:match('(.+)/.+%.%S+$')))) then;    json.save(t,path);  end
        local f = io.open(path,'r+');   local T = decodeJson(f:read('*a')); f:close()
        return setmetatable(T,{
            __call = function(mytable) 
            	-- for k,v in pairs(mytable.reminders) do v.work = 0 end 
            	json.save(mytable,path) 
            end,
        })
    end
},{
    __call = function(self, n, func, ...)
        if not doesDirectoryExist(getWorkingDirectory()..'/config/') then createDirectory(getWorkingDirectory()..'/config/') end
    end,
})
j = json.load({
	lang = 1,
	reminders = {

	},
},getWorkingDirectory()..'/config/reminders.json')
function L(text)
	if j.lang == 1 then return text end
	local l ={
		[' '] = 'Add reminder',
		[''] = 'reminder',
		[''] = 'Name',
		[' '] = 'Set a reminder',
		['   !'] = 'no errors in the code!',
		[''] = 'repeat',
		['    '] = 'Select which day the reminder is for',
		[''] = 'delete',
		['..'] = 'More..',
		[' ((24 )::)'] = 'set hour(h(24 format):m:s)',
		[' '] = 'text reminder',
		['      '] = 'run the contents of the reminder text as lua code',
		
		[''] = 'Month',
		[''] = 'Months',
		[''] = 'Day',
		[''] = 'Days',
		[''] = 'Hour',
		[''] = 'Hours',
		[''] = 'Hours',
		[''] = 'Minute',
		[''] = 'Minutes',
		[''] = 'Minutes',
		[''] = 'Second',
		[''] = 'Seconds',
		[''] = 'Seconds',
	}
	return l[text] or text..'(L=return nil)'
end


window = imgui.ImBool(false)
active = 'main'
reminders = {}

function main()
    while not isSampAvailable() do wait(0) end

    sampRegisterChatCommand('reminders',function() window.v = not window.v end)
    sampRegisterChatCommand('reminder',function(arg)
    	if #arg == 0 then sampAddChatMessage('/reminder [text]') return end
		table.insert(j.reminders,{
			name = L('') .. '/reminder', 
			text = arg,
			time = os.time({year = os.date("%Y"), month = os.date('%m'), day = os.date('%d')+1,hour = os.date('%H'), min = os.date('%M'), sec = os.date('%S'), isdst = false}),
			['repeat'] = {
				['Sat'] = false,
				['Sun'] = false,
				['Mon'] = false,
				['Tue'] = false,
				['Wed'] = false,
				['Thu'] = false,
				['Fri'] = false,
			},
			luacode = false,
			work = 0,
		}); j()
		active = #j.reminders
		window.v = true
	end)

	wait(-1)
end

function onD3DPresent()
    if isSampAvailable() then
		imgui.Process = window.v or #reminders~=0
		sw,sh = getScreenResolution()
	end
    if isSampAvailable() and not window.v then
    	for k,v in pairs(j.reminders) do
    		if v['repeat'][os.date('%a')] then
    			if (os.date('%H:%M:%S') == os.date('%H:%M:%S',v.time)) and ((os.date('%d',v.work) < os.date('%d')) or v.work == 0) then
    				if v.luacode then
    					local f,err = load(v.text)
    					if err == nil then
    						f()
    					end
    				end

	    			local t = j.reminders[k]
	    			t.clockAlpha = os.clock()
	    			t.K = k
	    			t.skipped = false
	    			table.insert(reminders,t)
	    			v.work = os.time()
	    			j()
	    		end
	    		if ( (os.date('%d',v.work) ~= os.date('%d')) and os.time() > v.time ) then
	    			local t = j.reminders[k]
	    			t.clockAlpha = os.clock()
	    			t.K = k
	    			t.skipped = true
	    			table.insert(reminders,t)
	    			v.work = os.time()
	    			j()
	    		end
    		end
    	end
    end
end

function imgui.OnDrawFrame()
	imgui.ShowCursor = window.v
	if #reminders~=0 then
		for k,v in pairs(reminders) do
			local V,t = imgui.ImBool(true), (os.clock()-v.clockAlpha)
			local x,y = imgui.CalcTextSize( u8( v.name ) ).x + 50, (#reminders == 0 and 0 or (k == 1 and 0 or ((#reminders-1)*65)) ) 
	        imgui.SetNextWindowSize(imgui.ImVec2(x,60),1)
	        imgui.SetNextWindowPos(imgui.ImVec2(sw/2-x/2,((sh-100)-y)-60/2), imgui.Cond.FirstUseEver)
	        imgui.PushStyleColor(11,( v.skipped and imgui.ImVec4(1,0,0,0.7) or imgui.GetStyle().Colors[11] ) )
	        imgui.PushStyleColor(12,( v.skipped and imgui.ImVec4(1,0,0,0.7) or imgui.GetStyle().Colors[12] ) )
	        imgui.PushStyleColor(13,( v.skipped and imgui.ImVec4(1,0,0,0.7) or imgui.GetStyle().Colors[13] ) )
	        imgui.PushStyleVar(0,(t*1.5) >= 1 and 1 or (t*1.5))
	        imgui.Begin(u8(v.name)..'##'..k,V,2)

	        if v.luacode then
	        	local _,err = load(v.text)
	        	imgui.Text(u8'lua code:')
	        	imgui.TextColored((err == nil and imgui.ImVec4(0.06,0.61,0,1) or imgui.ImVec4(0.61,0.06,0,1)),u8(err == nil and L('   !') or err))
	        	if imgui.Button(u8(L(' ')),imgui.ImVec2(-1,0)) then
	        		window.v = true
	        		main = v.K
	        		table.remove(reminders,k)
	        	end
	        else
		        if imgui.Button(u8(L('..'))..'##'..k,imgui.ImVec2(-1,-1)) then
		        	imgui.OpenPopup('rem '..k)
		        end
		    end

	        if imgui.BeginPopup('rem '..k) then
	        	if imgui.Button(u8(L(' '))) then
	        		window.v = true
	        		main = v.K
	        		table.remove(reminders,k)
	        	end
	        	imgui.InputTextMultiline('##textn',imgui.ImBuffer(u8(v.text)),imgui.ImVec2(500,150),16384)
	        	imgui.EndPopup()
	        end
	        imgui.End()
	        imgui.PopStyleVar()
	        imgui.PopStyleColor(3)
	        if V.v == false then
	        	table.remove(reminders,k)
	        end
	    end
	end


    if window.v then
        imgui.SetNextWindowSize(imgui.ImVec2(500,300),1)
        imgui.SetNextWindowPos(imgui.ImVec2(sw/2-500/2,sh/2-300/2), imgui.Cond.FirstUseEver)
        imgui.Begin('reminders by vespan',window,2)

        if type(active) ~= 'number' and active == 'main' then

        	imgui.SetCursorPos(imgui.ImVec2(500/2-200/2,25))
        	imgui.BeginChild('main',imgui.ImVec2(200,270),true)
        	imgui.SetCursorPosX(imgui.GetWindowWidth()/2-imgui.CalcTextSize('/reminder [text]').x/2)
        	imgui.Text('/reminder [text]')
        	imgui.SetCursorPosX(25)
        	for k,v in pairs({'','English'}) do
        		if imgui.RadioButton(u8(v),j.lang==k) then j.lang = k j() end
        		imgui.SameLine()
        	end
        	imgui.Spacing()
        	if imgui.Button(u8(L(' ')),imgui.ImVec2(-1,30)) then
        		table.insert(j.reminders,{
        			name = L(''),
        			text = L(' '),
        			time = os.time({year = os.date("%Y"), month = os.date('%m'), day = os.date('%d')+1,hour = os.date('%H'), min = os.date('%M'), sec = os.date('%S'), isdst = false}),
        			['repeat'] = {
						['Sat'] = false,
						['Sun'] = false,
						['Mon'] = false,
						['Tue'] = false,
						['Wed'] = false,
						['Thu'] = false,
						['Fri'] = false,
        			},
        			luacode = false,
        			work = 0,
        		})
        		j()
        	end
        	imgui.Separator()
        	for k,v in pairs(j.reminders) do
	        	if imgui.Button(u8(v.name)..'##'..k,imgui.ImVec2(-1,30)) then
	        		active = k
	        	end
        	end

        	imgui.EndChild()

        elseif type(active) == 'number' then
        	local v = j.reminders[active]
        	if v == nil or v.text == nil then active = 'main' goto s end 

        	imgui.SetCursorPosY(25)
        	if imgui.Button('<') then
        		active = 'main'
        	end
        	imgui.SameLine(imgui.GetWindowWidth()-imgui.CalcTextSize(u8(L(''))).x-30)
        	if imgui.Button(u8(L(''))) then
        		table.remove(j.reminders,active) j()
        		active = 'main'
        	end
        	imgui.SetCursorPosY(50)

        	local name = imgui.ImBuffer(u8(v.name),256)
        	local text = imgui.ImBuffer(u8(v.text),0xffff)
   			local luacode = imgui.ImBool(v.luacode)
   			local r = false
   			for k,v in pairs(v['repeat']) do if v then r = true end end

   			if imgui.InputText(u8(L('')),name) then j.reminders[active].name = u8:decode(name.v) j() end 

   			local calendarBool,newTime = imgui.Calendar('date','set',v.time,nil,nil)
   			if calendarBool then
				if newTime > j.reminders[active].time then j.reminders[active].work = 0 end
				j.reminders[active].time = newTime j()
   			end
   			imgui.SameLine()
   			imgui.Text(u8(os.date('%d.%m.%Y, %H:%M:%S | ',v.time) ..( r and convNameTimeBySec('%m %d %H %M %S',v.time) or L('    ') ) ))

   			for k,v in pairs(v['repeat']) do
   				if imgui.RadioButton(k,v) then
   					j.reminders[active]['repeat'][k] = (not v) 
   					j()
   				end
   				imgui.SameLine()
   			end
   			imgui.Spacing()

   			if imgui.Checkbox(u8(L('      ')),luacode) then j.reminders[active].luacode = luacode.v j() end

   			imgui.Spacing()

        	if imgui.InputTextMultiline('##text',text,imgui.ImVec2(-1,125 + (luacode.v and 0 or 18))) then j.reminders[active].text = u8:decode(text.v) j() end
        	if luacode.v then
        		local _,err = load(u8:decode(text.v))
        		imgui.TextColored((err == nil and imgui.ImVec4(0.06,0.61,0,1) or imgui.ImVec4(0.61,0.06,0,1)),u8(err == nil and L('   !') or err))
        	end

        	::s::
        end

        imgui.End()
    end

end

function convNameTimeBySec(f,sec)
	local n = {
		{p={L(''),L(''),L('')},sec = 2629744,f = '%m'},
		{p={L(''),L(''),L('')},sec = 86400,f = '%d'},
		{p={L(''),L(''),L('')},sec = 3600,f = '%H'},
		{p={L(''),L(''),L('')},sec = 60,f = '%M'},
		{p={L(''),L(''),L('')},sec = 1,f = '%S'},
	}
	local t = math.abs(os.time()-sec)
	for k,v in pairs(n) do
		if t > v.sec then
			f = f:gsub('%'..v.f,math.floor((t/v.sec)%60)..' '..plural(math.floor((t/v.sec)%60),v.p))
		else
			f = f:gsub('%'..v.f,'')
		end
	end
	-- f = f:gsub('%%a','')
	return f
end

function plural(n, forms)
	n = math.abs(n) % 100
	if n % 10 == 1 and n ~= 11 then
		return forms[1]
	elseif 2 <= n % 10 and n % 10 <= 4 and (n < 10 or n >= 20) then
		return forms[2]
	end
	return forms[3]
end

function onWindowMessage(_,k) 
	if k == VK_ESCAPE then window.v = false end
end

function apply_custom_style()
    imgui.SwitchContext()
    local style = imgui.GetStyle()
    local colors = style.Colors
    local clr = imgui.Col
    local ImVec4 = imgui.ImVec4

    style.WindowRounding = 2.0
    style.WindowTitleAlign = imgui.ImVec2(0.5, 0.5)
    style.ChildWindowRounding = 2.0
    style.FrameRounding = 5.0
    style.ItemSpacing = imgui.ImVec2(5.0, 4.0)
    style.ScrollbarSize = 13.0
    style.ScrollbarRounding = 0
    style.GrabMinSize = 8.0
    style.GrabRounding = 1.0

    colors[clr.FrameBg]                = ImVec4(0.16, 0.29, 0.48, 0.54)
    colors[clr.FrameBgHovered]         = ImVec4(0.26, 0.59, 0.98, 0.40)
    colors[clr.FrameBgActive]          = ImVec4(0.26, 0.59, 0.98, 0.67)
    colors[clr.TitleBg]                = ImVec4(0.04, 0.04, 0.04, 1.00)
    colors[clr.TitleBgActive]          = ImVec4(0.16, 0.29, 0.48, 1.00)
    colors[clr.TitleBgCollapsed]       = ImVec4(0.00, 0.00, 0.00, 0.51)
    colors[clr.CheckMark]              = ImVec4(0.26, 0.59, 0.98, 1.00)
    colors[clr.SliderGrab]             = ImVec4(0.24, 0.52, 0.88, 1.00)
    colors[clr.SliderGrabActive]       = ImVec4(0.26, 0.59, 0.98, 1.00)
    colors[clr.Button]                 = ImVec4(0.26, 0.59, 0.98, 0.40)
    colors[clr.ButtonHovered]          = ImVec4(0.26, 0.59, 0.98, 1.00)
    colors[clr.ButtonActive]           = ImVec4(0.06, 0.53, 0.98, 1.00)
    colors[clr.Header]                 = ImVec4(0.26, 0.59, 0.98, 0.31)
    colors[clr.HeaderHovered]          = ImVec4(0.26, 0.59, 0.98, 0.80)
    colors[clr.HeaderActive]           = ImVec4(0.26, 0.59, 0.98, 1.00)
    colors[clr.Separator]              = colors[clr.Border]
    colors[clr.SeparatorHovered]       = ImVec4(0.26, 0.59, 0.98, 0.78)
    colors[clr.SeparatorActive]        = ImVec4(0.26, 0.59, 0.98, 1.00)
    colors[clr.ResizeGrip]             = ImVec4(0.26, 0.59, 0.98, 0.25)
    colors[clr.ResizeGripHovered]      = ImVec4(0.26, 0.59, 0.98, 0.67)
    colors[clr.ResizeGripActive]       = ImVec4(0.26, 0.59, 0.98, 0.95)
    colors[clr.TextSelectedBg]         = ImVec4(0.26, 0.59, 0.98, 0.35)
    colors[clr.Text]                   = ImVec4(1.00, 1.00, 1.00, 1.00)
    colors[clr.TextDisabled]           = ImVec4(0.50, 0.50, 0.50, 1.00)
    colors[clr.WindowBg]               = ImVec4(0.06, 0.06, 0.06, 0.94)
    colors[clr.ChildWindowBg]          = ImVec4(1.00, 1.00, 1.00, 0.00)
    colors[clr.PopupBg]                = ImVec4(0.08, 0.08, 0.08, 0.94)
    colors[clr.ComboBg]                = colors[clr.PopupBg]
    colors[clr.Border]                 = ImVec4(0.43, 0.43, 0.50, 0.50)
    colors[clr.BorderShadow]           = ImVec4(0.00, 0.00, 0.00, 0.00)
    colors[clr.MenuBarBg]              = ImVec4(0.14, 0.14, 0.14, 1.00)
    colors[clr.ScrollbarBg]            = ImVec4(0.02, 0.02, 0.02, 0.53)
    colors[clr.ScrollbarGrab]          = ImVec4(0.31, 0.31, 0.31, 1.00)
    colors[clr.ScrollbarGrabHovered]   = ImVec4(0.41, 0.41, 0.41, 1.00)
    colors[clr.ScrollbarGrabActive]    = ImVec4(0.51, 0.51, 0.51, 1.00)
    colors[clr.CloseButton]            = ImVec4(0.41, 0.41, 0.41, 0.50)
    colors[clr.CloseButtonHovered]     = ImVec4(0.98, 0.39, 0.36, 1.00)
    colors[clr.CloseButtonActive]      = ImVec4(0.98, 0.39, 0.36, 1.00)
    colors[clr.PlotLines]              = ImVec4(0.61, 0.61, 0.61, 1.00)
    colors[clr.PlotLinesHovered]       = ImVec4(1.00, 0.43, 0.35, 1.00)
    colors[clr.PlotHistogram]          = ImVec4(0.90, 0.70, 0.00, 1.00)
    colors[clr.PlotHistogramHovered]   = ImVec4(1.00, 0.60, 0.00, 1.00)
    colors[clr.ModalWindowDarkening]   = ImVec4(0.80, 0.80, 0.80, 0.35)
end
apply_custom_style()

local origsampAddChatMessage = sampAddChatMessage
function sampAddChatMessage(text,...); origsampAddChatMessage((tostring(text)):format(...),-1); end

function imgui.Calendar(label,buttonName,time,days,sizebutton)
    days = days or {['mo'] = 'Mo',['tu'] = 'Tu',['we'] = 'We',['th'] = 'Th',['fr'] = 'Fr',['sa'] = 'Sa',['su'] = 'Su',}
    local daysInMonths = {31,28,31,30,31,30,31,31,30,31,30,31}
    if imgui_calendar == nil then imgui_calendar = {} end
    if imgui_calendar[label] == nil then imgui_calendar[label] = {
        previousDate = time
    } end
    local t,editTime = imgui_calendar[label],time
    local hours,minutes,seconds = imgui.ImInt(os.date('%H',time)),imgui.ImInt(os.date('%M',time)),imgui.ImInt(os.date('%S',time))
    if imgui.Button(os.date(buttonName,time),sizebutton or imgui.ImVec2(0,0)) then
        imgui.OpenPopup(label)
    end
    if imgui.BeginPopup(label) then

        imgui.SetCursorPosX(imgui.GetWindowWidth() /2 - imgui.CalcTextSize(os.date('%B %Y',time)).x /2)
        imgui.Text(os.date('%B %Y',time))
        local Y = imgui.GetCursorPosY()-imgui.CalcTextSize(os.date('%B %Y',time)).y

        if t.previousDate ~= time then
            imgui.SetCursorPosX(imgui.GetWindowWidth() /2 - imgui.CalcTextSize('previous date '..os.date('%d.%m.%Y',t.previousDate)).x /2)
            imgui.Text('previous date '..os.date('%d.%m.%Y',t.previousDate))
        end

        imgui.Spacing()
        imgui.Columns(7,'_',true)
        for k,v in pairs(days) do
            imgui.SetCursorPosX((imgui.GetColumnOffset() + (imgui.GetColumnWidth() / 2)) - imgui.CalcTextSize(tostring(v)).x / 2)
            imgui.Text(v)
            imgui.NextColumn()
        end
        for i = 1,daysInMonths[tonumber(os.date('%m',time))] do
            if i == 1 then
                local K = 0
                for k,v in pairs(days) do
                    K = K + 1
                    if (os.date('%a',(time-(86400*((tonumber(os.date('%d',time)))-1) ))):lower()):sub(1,2) == k then
                        for i = 1,K-1 do
                            imgui.NextColumn()
                        end
                    end
                end
            end
            imgui.SetCursorPosX((imgui.GetColumnOffset() + (imgui.GetColumnWidth() / 2)) - imgui.CalcTextSize(tostring(i)).x+5 / 2)
            imgui.PushStyleColor(23,imgui.GetStyle().Colors[(os.date('%d',time):gsub('^0','') == tostring(i) and 25 or 23)] )
            if imgui.Button(tostring(i)) then
                time = os.time({year = os.date("%Y",time), month = os.date('%m',time), day = i,hour = os.date('%H',time), min = os.date('%M',time), sec = os.date('%S',time), isdst = false})
            end
            imgui.PopStyleColor()
            imgui.NextColumn()
        end

        imgui.Columns(1)
        imgui.Text(string.rep('\t',15))
        imgui.Text(u8(L(' ((24 )::)')))
        imgui.SameLine()
        imgui.PushItemWidth(30)
        if imgui.InputInt(':##hour',hours,0,0) then
        	if hours.v > 24 then hours.v = 24 end
            time = os.time({year = os.date("%Y",time), month = os.date('%m',time), day = os.date('%d',time),hour = hours.v, min = os.date('%M',time), sec = os.date('%S',time), isdst = false})
        end
        imgui.SameLine()
        if imgui.InputInt(':##minute',minutes,0,0) then
        	if minutes.v > 60 then minutes.v = 60 end
            time = os.time({year = os.date("%Y",time), month = os.date('%m',time), day = os.date('%d',time),hour = os.date('%H',time), min = minutes.v, sec = os.date('%S',time), isdst = false})
        end
        imgui.SameLine()
        if imgui.InputInt('##second',seconds,0,0) then
        	if seconds.v > 60 then seconds.v = 60 end
            time = os.time({year = os.date("%Y",time), month = os.date('%m',time), day = os.date('%d',time),hour = os.date('%H',time), min = os.date('%M',time), sec = seconds.v, isdst = false})
        end
        imgui.PopItemWidth()
        -- <|>
        imgui.SetCursorPos(imgui.ImVec2(imgui.GetWindowWidth()-imgui.CalcTextSize('>').x-16,Y-2.5))
        if imgui.SmallButton('>') then
            time = os.time({year = os.date("%Y",time), month = os.date('%m',time)+1, day = 1,hour = os.date('%H',time), min = os.date('%M',time), sec = os.date('%S',time), isdst = false})
        end

        imgui.SetCursorPos(imgui.ImVec2(6,Y-2.5))
        if imgui.SmallButton('<') then
            time = os.time({year = os.date("%Y",time), month = os.date('%m',time)-1, day = 1,hour = os.date('%H',time), min = os.date('%M',time), sec = os.date('%S',time), isdst = false})
        end

        imgui.EndPopup()
    end
    if not imgui.IsPopupOpen(label) then imgui_calendar[label] = nil end
    return editTime ~= time, time
end